$(document).ready(function () {

    $('#tblProductionPlan').DataTable({
        "scrollX": true,
        "order": [],
        "columns": [
            { "data": "date" },
            { "data": "factory" },
            { "data": "machine" },
            { "data": "breakdown_time" },
            { "data": "status" },
            { "data": "orders", className: "orders" },
        ],
        columnDefs: [
            { width: 80, targets: 0 },
            { width: 140, targets: 5,},
        ],
    });

    allPendingMachineBreakdown();

    $('#btnAddDailyProductionModel').on('click', function () {

        //$('#txtDate').val('');
        $('#cmbMachine').empty();
        $('#txtBreakdownTime').val('');
        $('#txtReasonOfBreakdown').val('');
        $('#txtRecoveredTime').val('');
        $('#txtRecoveryDetails').val('');
        $('#txtTechnicalInstruction').val('');
        $('.updateInput').hide();
        $('#btnAction').show();
        $('#btnAction').text('Save');
        $('#dailyProductionModal').modal('show');
    });

});




function allPendingMachineBreakdown() {
    $('#dailyProductionModal').modal('hide');
    $.ajax({
        type: "GET",
        url: "/pd/PendingMachineBreakdownController/allPendingMachineBreakdown",
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            var res = response.data.result;
            console.log(response);
            if (response.data.success) {
                var data = [];

                for (i = 0; i < response.data.result.length; i++) {


                    var id = response.data.result[i]['id'];
                    var date = response.data.result[i]['date'];
                    var factory = response.data.result[i]['site'];
                    var machine = response.data.result[i]['machinery_name'];
                    var breakdown_time = response.data.result[i]['breakdown_time'];
                    var status = response.data.result[i]['status'];
                    var orders = response.data.result[i]['orders'];
                    var string_id = "'" + id + "'";

                    var status_icon = '<div style="text-align:center;"><span class="badge bg-primary text-primary-bright ">Pending</span><div>';
                    if (status == 0) {
                        status_icon = '<div style="text-align:center;"><span class="badge bg-primary text-primary-bright ">Pending</span></div>';
                    } else if (status == 1) {
                        status_icon = '<div style="text-align:center;"><span class="badge bg-success text-success-bright ">Recovered</span></div>';
                    } else if (status == 2) {
                        status_icon = '<div style="text-align:center;"><span class="badge bg-warning text-warning-bright ">Not Possible</span></div>';
                    }

                    data.push({
                        "date": date,
                        "factory": factory,
                        "machine": machine,
                        "breakdown_time": breakdown_time,
                        "status": status_icon,
                        "orders": '<div class="row"> <div class="col-md-2" style="vertical-align: middle;"><span style="font-size:18px;height:100%,padding:10px;width:100%;font-weight: bold;">'+orders+'</span></div><div class="col-md-6"><button class="btn btn-primary" style="width:100%" onclick="more(' + string_id + ')">More</button></div></div>',

                    });
                }

                var table = $('#tblProductionPlan').DataTable();
                table.clear();
                table.rows.add(data).draw();
            }
        },
        error: function (error) {
            console.log(error);


        },
        complete: function () {

        }

    });
}


function edit(id) {
    //location.href = "/pd/daily_production?id=" + id + "&action=edit";
    daily_production_id = id;
    $('.updateInput').show();
    getDailyProduction(id);
    $('#dailyProductionModal').modal('show');
    $('#btnAction').show();
    $('#btnAction').text('Update');

}



function more(id) {
    daily_production_id = id;
    $('#pendingBreakdownModal').modal('show');
}



function _delete(id) {
    $.ajax({
        type: 'DELETE',
        url: '/pd/ReasonOfBreakdownController/delete/' + id,
        data: {
            _token: $('input[name=_token]').val()
        },
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                showSuccessMessage("Reason of breakdown has been deleted successfully...")
                allDailyProduction();
            } else {
                showErrorMessage();
            }
        },
        error: function (error) {
            console.log(error);
            showErrorMessage();
        },
        complete: function () {

        }

    });
}





/**
* showSuccessMessage
* This function is used to show success message.
* @param message This is the paramter to require message content
*/
function showSuccessMessage(message) {
    toastr.success(message);
}


/**
* showWarningMessage
* This function is used to show warning message.
* @param message This is the paramter to require message content
*/
function showWarningMessage(message) {
    toastr.warning(message);
}



/**
* showErrorMessage
* This function is used to show error message.
* @param message This is the paramter to require message content
*/
function showErrorMessage() {
    toastr.error('Something went wrong');
}